SystemOrganization addCategory: #'Poll-Commands'!
SystemOrganization addCategory: #'Poll-Model'!
SystemOrganization addCategory: #'Poll-Visitor'!
SystemOrganization addCategory: #'Poll-View'!

PRStructure subclass: #POPoll
	instanceVariableNames: 'options uuid deadline'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poll-Model'!

!POPoll class methodsFor: 'testing' stamp: 'pmm 8/23/2008 17:58'!
canVote
	^PRCurrentContext value structure canVote! !

!POPoll class methodsFor: 'accessing-description' stamp: 'lr 6/24/2009 09:35'!
descriptionDeadline
	^ MATimeStampDescription new
		accessor: #deadline;
		label: 'Deadline';
		priority: 300;
		beEditable;
		yourself.! !

!POPoll class methodsFor: 'accessing-description' stamp: 'pmm 3/29/2006 11:41'!
descriptionName
	^super descriptionName
		beHidden;
		yourself! !

!POPoll class methodsFor: 'accessing-description' stamp: 'lr 6/24/2009 09:34'!
descriptionOptions
	^ MAToManyRelationDescription new
		classes: (Array with: POPollOption);
		default: OrderedCollection new;
		accessor: #options;
		label: 'Options';
		priority: 200;
		beEditable;
		yourself.! !

!POPoll class methodsFor: 'accessing-description' stamp: 'lr 6/24/2009 09:36'!
descriptionTitle
	^ super descriptionTitle
		label: 'Question';
		yourself! !

!POPoll class methodsFor: 'accessing-description' stamp: 'lr 6/24/2009 09:35'!
descriptionUUID
	^ MAStringDescription new
		accessor: #uuid;
		priority: 1000;
		label: 'UUId';
		beReadonly;
		beHidden;
		yourself.! !

!POPoll class methodsFor: 'testing' stamp: 'pmm 12/18/2005 15:45'!
isAbstract
	^false! !

!POPoll class methodsFor: 'accessing' stamp: 'pmm 12/18/2005 15:48'!
label
	^'Poll'! !

!POPoll methodsFor: 'visiting' stamp: 'pmm 8/23/2008 18:10'!
accept: aVisitor
	aVisitor visitPoll: self! !

!POPoll methodsFor: 'accessing' stamp: 'pmm 3/4/2007 17:43'!
addOption: anOption
	^self options add: anOption! !

!POPoll methodsFor: 'testing' stamp: 'pmm 8/23/2008 17:56'!
canVote
	^self hasAlreadyVoted not
		and: [ self hasExpired not ]! !

!POPoll methodsFor: 'accessing' stamp: 'pmm 1/28/2006 10:20'!
cookieName
	^'pierPoll' , self uuid! !

!POPoll methodsFor: 'accessing' stamp: 'pmm 8/23/2008 17:52'!
deadline
	^ deadline! !

!POPoll methodsFor: 'accessing' stamp: 'pmm 8/23/2008 17:52'!
deadline: aDeadline
	deadline := aDeadline! !

!POPoll methodsFor: 'accessing' stamp: 'lr 6/24/2009 09:51'!
defaultCommandClass
	^ self canVote
		ifTrue: [ POVoteCommand ]
		ifFalse: [ super defaultCommandClass ]! !

!POPoll methodsFor: 'testing' stamp: 'pmm 8/23/2008 12:45'!
hasAlreadyVoted
	| cookies |
	cookies := WACurrentSession value currentRequest cookies.
	^(cookies includesKey: self cookieName)! !

!POPoll methodsFor: 'testing' stamp: 'pmm 8/23/2008 17:54'!
hasExpired
	^self deadline notNil
		and: [ self deadline < TimeStamp now ]! !

!POPoll methodsFor: 'initialize-release' stamp: 'pmm 1/28/2006 10:03'!
initialize
	super initialize.
	uuid := UUID new printString.
	self options: OrderedCollection new! !

!POPoll methodsFor: 'testing' stamp: 'pmm 8/24/2008 10:08'!
isValidView: aComponentClass in: aContext
	^(super isValidView: aComponentClass in: aContext)
		and: [ aComponentClass ~= super viewComponentClass ]! !

!POPoll methodsFor: 'accessing' stamp: 'pmm 12/18/2005 15:44'!
options
	^options! !

!POPoll methodsFor: 'accessing' stamp: 'pmm 12/18/2005 15:44'!
options: aCollection 
	options := aCollection! !

!POPoll methodsFor: 'copying' stamp: 'pmm 3/3/2006 20:29'!
postCopy
	super postCopy.
	self options: (self options collect: [ :each | each copy ])! !

!POPoll methodsFor: 'accessing' stamp: 'pmm 12/18/2005 15:45'!
totalVotes
	^self options inject: 0 into: [ :sum :each |
		sum + each votes ]! !

!POPoll methodsFor: 'accessing' stamp: 'pmm 1/28/2006 10:02'!
uuid
	^uuid! !

!POPoll methodsFor: 'accessing-commands' stamp: 'pmm 8/23/2008 18:06'!
viewComponentClass
	^self viewComponentClasses
		detect: [ :each | each isSupported ]
		ifNone: [ super viewComponentClass ]! !

!POPoll methodsFor: 'accessing-commands' stamp: 'pmm 8/23/2008 18:06'!
viewComponentClasses
	^Array
		with: POCanvasBarPollResultsView
		with: POCanvasPiePollResultsView
		with: POMorphPollResultsView! !

!PRVisitor methodsFor: '*Poll' stamp: 'pmm 12/18/2005 17:07'!
visitPoll: aPoll
	self visitStructure: aPoll! !

PRObject subclass: #POPollOption
	instanceVariableNames: 'text votes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poll-Model'!

!POPollOption class methodsFor: 'accessing-description' stamp: 'lr 6/24/2009 09:34'!
descriptionText
	^ MAStringDescription new
		accessor: #text;
		label: 'Text';
		priority: 100;
		beRequired;
		yourself! !

!POPollOption class methodsFor: 'accessing-description' stamp: 'lr 6/24/2009 09:33'!
descriptionVotes
	^ MANumberDescription new
		accessor: #votes;
		label: 'Votes';
		priority: 200;
		default: 0;
		beHidden;
		yourself! !

!POPollOption class methodsFor: 'testing' stamp: 'pmm 12/18/2005 15:39'!
isAbstract
	^false! !

!POPollOption methodsFor: 'actions' stamp: 'pmm 12/22/2005 16:45'!
addVote
	self votes: self votes + 1! !

!POPollOption methodsFor: 'testing' stamp: 'pmm 2/10/2006 20:12'!
hasVotes
	^self votes isZero not! !

!POPollOption methodsFor: 'accessing' stamp: 'pmm 12/22/2005 16:28'!
label
	^self text! !

!POPollOption methodsFor: 'copying' stamp: 'pmm 3/3/2006 20:27'!
postCopy
	super postCopy.
	self votes: 0! !

!POPollOption methodsFor: 'printing' stamp: 'pmm 12/22/2005 16:34'!
printOn: aStream
	super printOn: aStream.
	self text isNil ifFalse: [
		aStream
			nextPut: $(;
			nextPutAll: self text;
			nextPut: $) ]! !

!POPollOption methodsFor: 'accessing' stamp: 'pmm 12/18/2005 15:38'!
text
	^text! !

!POPollOption methodsFor: 'accessing' stamp: 'pmm 12/18/2005 15:43'!
text: aString 
	text := aString! !

!POPollOption methodsFor: 'accessing' stamp: 'pmm 8/23/2008 11:10'!
votes
	votes isNil ifTrue: [
		votes := 0 ].
	^votes! !

!POPollOption methodsFor: 'accessing' stamp: 'pmm 12/18/2005 15:43'!
votes: anInteger 
	votes := anInteger! !

PRCommand subclass: #POVoteCommand
	instanceVariableNames: 'vote'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poll-Commands'!

!POVoteCommand class methodsFor: 'testing' stamp: 'pmm 12/22/2005 16:21'!
isAbstract
	^false! !

!POVoteCommand class methodsFor: 'testing' stamp: 'pmm 1/28/2006 10:24'!
isHttp
	^WACurrentSession value notNil! !

!POVoteCommand class methodsFor: 'testing' stamp: 'pmm 8/23/2008 17:57'!
isValidIn: aContext
	^(super isValidIn: aContext)
		and: [ self isHttp not or: [ POPoll canVote ] ]! !

!POVoteCommand class methodsFor: 'accessing' stamp: 'pmm 12/18/2005 16:28'!
label
	^'Vote'! !

!POVoteCommand class methodsFor: 'accessing' stamp: 'pmm 1/29/2006 11:41'!
structureClass
	^POPoll ! !

!POVoteCommand methodsFor: 'private' stamp: 'pmm 8/23/2008 11:15'!
addCookie
	| voteCookie |
	voteCookie := (WACookie
		key: self structure cookieName
		value: self vote text)
		expiry: (DateAndTime year: 2095 month: 1 day: 1 hour: 12 minute: 0);
		yourself.
	self session redirectWithCookie: voteCookie! !

!POVoteCommand methodsFor: 'accessing-description' stamp: 'pmm 12/22/2005 16:38'!
description
	^super description copy
		add: self descriptionVote;
		yourself! !

!POVoteCommand methodsFor: 'accessing-description' stamp: 'lr 6/24/2009 09:33'!
descriptionVote
	^ MASingleOptionDescription new
		accessor: #vote;
		label: 'Vote';
		priority: 200;
		options: self options;
		reference: (POPollOption description
			stringWriter: POLabelWriter;
			yourself);
		componentClass: MARadioGroupComponent;
		beRequired;
		yourself! !

!POVoteCommand methodsFor: 'events' stamp: 'pmm 1/28/2006 10:23'!
doExecute
	super doExecute.
	self vote addVote.
	self isHttp
		ifTrue: [ self addCookie ]! !

!POVoteCommand methodsFor: 'testing' stamp: 'pmm 1/28/2006 10:24'!
isHttp
	^self class isHttp ! !

!POVoteCommand methodsFor: 'accessing' stamp: 'pmm 12/18/2005 16:29'!
options
	^self structure options! !

!POVoteCommand methodsFor: 'accessing' stamp: 'pmm 2/10/2006 20:13'!
session
	^WACurrentSession value! !

!POVoteCommand methodsFor: 'accessing' stamp: 'pmm 12/18/2005 16:36'!
vote
	^vote! !

!POVoteCommand methodsFor: 'accessing' stamp: 'pmm 2/10/2006 19:42'!
vote: aPollOption 
	vote := aPollOption! !

MAStringWriter subclass: #POLabelWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poll-Visitor'!

!POLabelWriter methodsFor: 'visiting' stamp: 'pmm 12/22/2005 16:27'!
write: anObject description: aDescription
	^anObject label! !

PRViewComponent subclass: #POPollResultsView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poll-View'!

POPollResultsView subclass: #POCanvasPollResultsView
	instanceVariableNames: 'chart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poll-View'!

POCanvasPollResultsView subclass: #POCanvasBarPollResultsView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poll-View'!

!POCanvasBarPollResultsView class methodsFor: 'testing' stamp: 'pmm 8/8/2006 21:35'!
isAbstract
	^false! !

!POCanvasBarPollResultsView class methodsFor: 'accessing' stamp: 'pmm 3/5/2007 17:36'!
label
	^'Bar Chart'! !

!POCanvasBarPollResultsView methodsFor: 'private' stamp: 'pmm 8/8/2006 21:37'!
newChart
	| barChart |
	barChart := PKChart newBarChart.
	barChart layoutOptions beHorizontal.
	^barChart! !

POCanvasPollResultsView subclass: #POCanvasPiePollResultsView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poll-View'!

!POCanvasPiePollResultsView class methodsFor: 'testing' stamp: 'pmm 8/8/2006 21:32'!
isAbstract
	^false! !

!POCanvasPiePollResultsView class methodsFor: 'accessing' stamp: 'pmm 3/5/2007 17:36'!
label
	^'Pie Chart'! !

!POCanvasPiePollResultsView methodsFor: 'private' stamp: 'pmm 8/8/2006 21:34'!
newChart
	^PKChart newPieChart! !

!POCanvasPollResultsView class methodsFor: 'testing' stamp: 'pmm 8/8/2006 20:18'!
isSupported
	^self environment hasClassNamed: #PKChart! !

!POCanvasPollResultsView class methodsFor: 'accessing' stamp: 'pmm 2/11/2006 10:41'!
label
	^'View Canvas'! !

!POCanvasPollResultsView methodsFor: 'accessing' stamp: 'pmm 8/8/2006 21:34'!
chart
	chart isNil ifTrue: [
		self createChart ].
	^chart! !

!POCanvasPollResultsView methodsFor: 'accessing' stamp: 'pmm 12/22/2005 17:12'!
chart: anObject
	chart := anObject! !

!POCanvasPollResultsView methodsFor: 'accessing' stamp: 'pmm 12/22/2005 17:13'!
children
	^Array with: self chart! !

!POCanvasPollResultsView methodsFor: 'private' stamp: 'pmm 2/5/2007 00:03'!
createChart
	self chart: self newChart.
	self chart renderer: PKSweetCanvasRenderer new.
	self chart layout addDataset: self dataset.
	self chart layoutOptions xTicks: self xLabels.
	self chart width: self chartWidth; height: self chartHeight.
	self chart rendererOptions paddingLeft: 50 right: 50 top: 50 bottom: 50.
	self chart id: 'result' , self poll name! !

!POCanvasPollResultsView methodsFor: 'private' stamp: 'pmm 8/8/2006 21:24'!
dataset
	| index data |
	index := 0.
	data := self pollOptionsWithVotes collect: [ :each |
		index := index + 1.
		Array with: index with: each votes ].
	^PKDataset name: self poll title data: data! !

!POCanvasPollResultsView methodsFor: 'private' stamp: 'pmm 8/8/2006 21:33'!
newChart
	self subclassResponsibility ! !

!POCanvasPollResultsView methodsFor: 'rendering' stamp: 'pmm 12/22/2005 17:17'!
renderContentOn: html
	html render: self chart! !

!POCanvasPollResultsView methodsFor: 'private' stamp: 'pmm 3/3/2006 20:51'!
xLabels
	| index labels |
	labels := Dictionary new.
	index := 0.
	self pollOptionsWithVotes do: [ :each |
		index := index + 1.
		labels at: index put: each text ].
	^labels! !

POPollResultsView subclass: #POMorphPollResultsView
	instanceVariableNames: 'morph morphUrl'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poll-View'!

!POMorphPollResultsView class methodsFor: 'testing' stamp: 'pmm 2/10/2006 21:57'!
isAbstract
	^false! !

!POMorphPollResultsView class methodsFor: 'testing' stamp: 'pmm 2/11/2006 08:33'!
isSupported
	^self environment hasClassNamed: #PCPieChartMorph! !

!POMorphPollResultsView class methodsFor: 'accessing' stamp: 'pmm 3/5/2007 17:37'!
label
	^'Pie Chart (ugly and slow)'! !

!POMorphPollResultsView methodsFor: 'private' stamp: 'pmm 2/10/2006 23:14'!
createMorph
	| values |
	values := self pollOptionValues.
	morph := PCPieChartMorph values: values.
	morph extent: self chartWidth @ self chartHeight.
	morph colors: (Color wheel: values size saturation: 0.25 brightness: 1).
	morph references: self pollOptionLabels.
	morph showLabels! !

!POMorphPollResultsView methodsFor: 'testing' stamp: 'pmm 9/28/2006 23:48'!
hasAnybodyVoted
	^self pollOptionValues notEmpty! !

!POMorphPollResultsView methodsFor: 'accessing' stamp: 'pmm 3/3/2006 20:39'!
morph
	morph isNil ifTrue: [
		self createMorph ].
	^morph! !

!POMorphPollResultsView methodsFor: 'private' stamp: 'pmm 3/3/2006 20:40'!
morphUrlIn: html
	morphUrl isNil ifTrue: [
		morphUrl := html context
			urlForDocument: self morph
			mimeType: 'image/gif' ].
	^morphUrl! !

!POMorphPollResultsView methodsFor: 'accessing' stamp: 'pmm 2/10/2006 23:27'!
pollOptionLabels
	| amount |
	amount := self pollOptionsWithVotes inject: 0 into: [ :sum : each | sum + each votes ].
	^self pollOptionsWithVotes collect: [ :each |
		String streamContents: [ :stream |
			stream
				nextPutAll: each text;
				nextPutAll: ' (';
				nextPutAll: (100 * each votes // amount) displayString;
				nextPutAll: '%)' ] ]! !

!POMorphPollResultsView methodsFor: 'accessing' stamp: 'pmm 2/10/2006 22:49'!
pollOptionValues
	^self pollOptionsWithVotes collect: [ :each | each votes ]! !

!POMorphPollResultsView methodsFor: 'rendering' stamp: 'pmm 9/28/2006 23:50'!
renderContentOn: html
	self hasAnybodyVoted
		ifTrue: [ self renderMorphOn: html ]
		ifFalse: [ self renderNoVotesOn: html ]! !

!POMorphPollResultsView methodsFor: 'rendering' stamp: 'pmm 9/28/2006 23:49'!
renderMorphOn: html
	html image
		width: self chartWidth;
		height: self chartHeight;
		altText: 'poll results';
		url: (self morphUrlIn: html)! !

!POMorphPollResultsView methodsFor: 'rendering' stamp: 'pmm 9/28/2006 23:50'!
renderNoVotesOn: html
	html strong: 'nobody has yet voted'! !

!POPollResultsView class methodsFor: 'testing' stamp: 'pmm 3/3/2006 20:50'!
isSupported
	self subclassResponsibility ! !

!POPollResultsView class methodsFor: 'testing' stamp: 'pmm 2/11/2006 08:35'!
isValidIn: aContext
	^(super isValidIn: aContext)
		and: [ aContext structure isKindOf: POPoll ]
		and: [ self isSupported ]! !

!POPollResultsView methodsFor: 'private' stamp: 'pmm 2/10/2006 23:13'!
chartHeight
	^400! !

!POPollResultsView methodsFor: 'private' stamp: 'pmm 2/10/2006 23:13'!
chartWidth
	^400! !

!POPollResultsView methodsFor: 'accessing' stamp: 'pmm 8/24/2008 10:09'!
label
	^self poll title! !

!POPollResultsView methodsFor: 'accessing' stamp: 'pmm 3/3/2006 20:32'!
poll
	^self context structure! !

!POPollResultsView methodsFor: 'accessing' stamp: 'pmm 2/10/2006 21:55'!
pollOptions
	^self poll options! !

!POPollResultsView methodsFor: 'accessing' stamp: 'pmm 2/10/2006 21:55'!
pollOptionsWithVotes
	^self pollOptions select: [ :each | each hasVotes ]! !
